
#include "stdafx.h"
#include <PDF/PDFNet.h>
#include <PDF/ElementReader.h>
#include <PDF/ElementWriter.h>
#include <PDF/ElementBuilder.h>
#include <PDF/Element.h>
#include <iostream>

using namespace pdftron;
using namespace PDF;
using namespace SDF;
using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
	int ret = 0;
	PDFNet::Initialize();

	try
	{
		ElementBuilder eb;
		ElementReader page_reader;
		Element src_image_element;
		Element element;
		char *src_pdf_path = "C:\\image1.pdf";
		char *tar_pdf_path = "C:\\target.pdf";

		PDFDoc doc(src_pdf_path);
		doc.InitSecurityHandler();
		Page page = doc.GetPage(1);

		page_reader.Begin(page);

		while ((element = page_reader.Next()) != NULL) 	// Read page contents
		{
			Element::Type etype = element.GetType();
			GState gstate = element.GetGState();
			if (etype == Element::e_image) {
				src_image_element = element;
				break;
			}
		}
		page_reader.End();

		// Write new pdf
		PDFDoc tar_doc;
		ElementWriter writer;
		Page new_page = tar_doc.PageCreate(Rect(0, 0, 612, 794));
		writer.Begin(new_page);

		Image image_src(src_image_element.GetXObject());
		Common::Matrix2D ctm = src_image_element.GetCTM();
		eb.Reset();
		Element tar_image_element = eb.CreateImage(image_src, ctm);
		writer.WritePlacedElement(tar_image_element);
		writer.End();  
		tar_doc.PagePushBack(page);
		tar_doc.Save(tar_pdf_path, SDFDoc::e_remove_unused, NULL);
		cout << "Done." << endl;
	}
	catch(Common::Exception& e)
	{
		cout << e << endl;
		ret = 1;
	}
	catch(...)
	{
		cout << "Unknown Exception" << endl;
		ret = 1;
	}

	PDFNet::Terminate();
	return ret;
}
